// NFCe_Declarations.h : Statements by the methods of the module NFCe.
//

    #pragma region NFCe_METHODS
	// XML GNE
	int regAlterarValor_NFCe_Daruma(char* pszTagNFCe, char* pszValorTagNFCe);
	int regRetornarValor_NFCe_Daruma(char* pszTagNFCe, char* pszValorRetTagNFCe);
	
	// Abertura de cupom fiscal
	int aCFAbrir_NFCe_Daruma(char* pszCPF, char* pszNome, char* pszLgr, char* pszNro, char* pszBairro, char* pszcMun, char* pszMunicipio, char* pszUF, char* pszCEP);
	int aCFAbrirNumSerie_NFCe_Daruma(char* pszNNF, char* pszNSerie, char* pszCPF, char* pszNome, char* pszLgr, char* pszNro,char* pszBairro, char* pszcMun,char* pszMunicipio, char* pszUF, char* pszCEP);
	
	// Configurar Impostos
	int aCFConfImposto_NFCe_Daruma(char* pszNomeImposto, char* pszParametros);
	int aCFConfRastro_NFCe_Daruma(char* pszParametros);
	int aCFConfICMS00_NFCe_Daruma(char* pszOrig, char* pszCST, char* pszModBC, char* pszpICMS);
	int aCFConfICMS20_NFCe_Daruma(char* pszOrig, char* pszCST, char* pszModBC, char* pszpRedBC, char* pszpICMS);
	int aCFConfICMS40_NFCe_Daruma(char* pszOrig, char* pszCST, char* pszvICMSDeson, char* pszMotDesICMS);
	int aCFConfICMS60_NFCe_Daruma(char* pszOrig, char* pszCST, char* pszvBCSTRet, char* pszvICMSSTRet);
	int aCFConfICMS90_NFCe_Daruma(char* pszOrig, char* pszCST, char* pszModBC, char* pszpRedBC, char* pszpICMS, char* pszModBCST, char* pszpMVAST, char* pszpRedBCST, char*  pszvBCST, char* pszpICMSST, char* pszvICMSDeson, char* pszmotDesICMS);
	int aCFConfICMSSN102_NFCe_Daruma(char* pszOrig, char* pszCSOSN);
	int aCFConfICMSSN500_NFCe_Daruma(char* pszOrig, char* pszCSOSN, char* pszvBCSTRet, char*pszvICMSSTRet);
	int aCFConfICMSSN900_NFCe_Daruma(char* pszOrig, char* pszCSOSN, char* pszmodBC, char* pszpRedBC, char* pszpICMS, char* pszmodBCST, char* pszpMVAST,char* pszpRedBCST, char* pszvBCST, char* pszpICMSST, char* pszvICMSST, char* pszpCredSN, char* pszvCredICMSSN);
	int aCFConfPisAliq_NFCe_Daruma(char* pszCST, char* pszpPIS);
	int aCFConfPisQtde_NFCe_Daruma(char* pszCST, char* pszvAliqProd);
	int aCFConfPisNT_NFCe_Daruma(char* pszCST);
	int aCFConfPisOutr_NFCe_Daruma(char* pszCST, char* pszpPIS, char* pszvAliqProd);
	int aCFConfCofinsAliq_NFCe_Daruma(char* pszCST, char* pszpCOFINS);
	int aCFConfCofinsQtde_NFCe_Daruma(char* pszCST, char* pszvAliqProd);
	int aCFConfCofinsNT_NFCe_Daruma(char* pszCST);
	int aCFConfCofinsOutr_NFCe_Daruma(char* pszCST, char* pszpCOFINS, char* pszvAliqProd);

	//Lei do Imposto
	int aCFConfLeiImposto_NFCe_Daruma (char* pszNCM, char* pszEx, char* pszTipo, char* pszNacionalFed, char* pszImportadoFed, char* pszEstadual, char* pszMun);
	int aCFValorLeiImposto_NFCe_Daruma(char* pszValor);

	//Combustivel
	int aCFConfCombustivel_NFCe_Daruma (char* pszcProdANP, char* pszpMixGN, char* pszCODIF, char* pszqTemp, char* pszUFCons,char* pszqBCProd, char* pszvAliqProd, char* pszvCIDE, char* psznBico, char* psznBomba, char* psznTanque, char* pszvEncInicial, char* pszvEncFinal, char* pszUsoFuturo);

	// Registro de item
	int aCFVender_NFCe_Daruma(char* pszAliquota, char* pszQuantidade, char* pszPrecoUnitario, char* pszTipoDescAcresc, char* pszValorDescAcresc, char* pszCodigoItem, char* pszUnidadeMedida, char* pszDescricaoItem);
	int aCFVenderXml_NFCe_Daruma(char* pszXML);
	int aCFVenderCompleto_NFCe_Daruma(char* pszAliquota, char* pszQuantidade, char* pszPrecoUnitario, char* pszTipoDescAcresc, char* pszValorDescAcresc, char* pszCodigoItem, char* pszNCM, char* pszCFOP, char* pszUnidadeMedida, char* pszDescricaoItem, char* pszUsoFuturo);
	
	// Totalizacao de cupom fiscal
	int aCFTotalizar_NFCe_Daruma(char* pszTipoDescAcresc, char* pszValorDescAcresc);
	
	//Descricao do meios de pagamento de cupom fiscal
	int aCFEfetuarPagamento_NFCe_Daruma(char* pszFormaPgto, char* pszValor);
	int aCFEfetuarPagamentoCartao_NFCe_Daruma(char* pszTipoCartao, char* pszValorPgto, char* pszTipoIntegracao, char* pszCNPJCred, char* pszCodBandeira, char* pszAutorizacao, char* pszUsoFuturo);
	int aCFIdentificarCartao_NFCe_Daruma(char* pszCNPJ, char* pszBandeira, char* pszAutorizacao);

	//Encerramento de cupom fiscal
	int tCFEncerrar_NFCe_Daruma(char* pszMsgPromocional);
	int tCFEncerrarConfigMsg_NFCe_Daruma(char* pszMsgPromo, char* pszMsgFisco, char* pszUsoFuturo);

	//Cancelamento parcial de item
	int aCFCancelarItemParcial_NFCe_Daruma(char* pszNumItem, char* pszQtde);
	
	//Cancelamento de item
	int aCFCancelarItem_NFCe_Daruma(char* pszNumItem);
	
	//Lancar acrescimo apos a venda do item
	int aCFLancarAcrescimoItem_NFCe_Daruma(char* pszNumItem, char* pszTipoDescAcresc, char* pszValor);
	
	//Lancar desconto apos a venda do item
	int aCFLancarDescontoItem_NFCe_Daruma(char* pszNumItem, char* pszTipoDescAcresc, char* pszValor);
	
	//Cancelamento do acrescimo no item
	int aCFCancelarAcrescimoItem_NFCe_Daruma(char* pszNumItem);
	
	//Cancelamento do desconto do item
	int aCFCancelarDescontoItem_NFCe_Daruma(char* pszNumItem);
	
	//Estorno do meio de pagamento
	int aCFEstornarPagamento_NFCe_Daruma(char* pszFormaPgtoEstornado, char* pszFormaPgtoEfetivado, char* pszValor);
	
	//Cancelamento da NFCe em andamento ou apos encerramento
	int tCFCancelar_NFCe_Daruma(char* pszNNF, char* pszNSerie, char* pszChAcesso, char* pszProtAutorizacao, char* pszJustificativa);
	int tCFCancelarOffline_NFCe_Daruma(char* pszNNF, char* pszNSerie, char* pszChAcesso, char* pszJustificativa);
	int tCFCancelarParametrizado_NFCe_Daruma(char* pszNNF, char* pszNSerie, char* pszChAcesso, char* pszProtAutorizacao, char* pszJustificativa, char* pszParametros);
	int tCFInutilizar_NFCe_Daruma(char* psznNFInic, char* psznNFFim, char* pszNSerie, char* pszJustificativa);
	int tDescartarNota_NFCe_Daruma(char* pszNF, char* pszSerie, char* pszOpcao);

	//Outros
	int aCFMsgPromocional_NFCe_Daruma(char* pszMsgPromocional, char* pszTextoLivre);
	int aCFIdentificarConsumidor_NFCe_Daruma(char* pszCPF, char* pszNome, char* pszLgr, char* pszNro,char* pszBairro, char* pszcMun, char* pszMunicipio, char* pszUF, char* pszCEP, char* pszEmail);
	int aCFIdentificarTransportadora_NFCe_Daruma(char* pszCPF_CNPJ,char* pszNome, char* pszIE,char* pszEndereco, char* pszMunicipio,char* pszUF);

	//Metodos de Impressao
	int iCFImprimir_NFCe_Daruma(char* pszPathXMLVenda,char* pszPathRetornoWS,char* pszLinkQrCode, int iNumColunas, int iTipoNF);
	int iCFImprimirParametrizado_NFCe_Daruma(char* pszPathXMLVenda,char* pszPathRetornoWS,char* pszLinkQrCode, int iNumColunas,int iTipoNF, char* pszParametros);
	int iCFReImprimir_NFCe_Daruma(char* pszNNF, char* pszSerie, char* pszChaveAcesso);
	int iTEFImprimirResposta_NFCe_Daruma(char* pszPathNomeArquivo, int iNumeroVias, int iCorteEntreVias, int iTravarTeclado);

	//Metodos de Retornos e Status
	int rAvisoErro_NFCe_Daruma(char* pszCodigo, char* pszMensagem);
	int rCFVerificarStatus_NFCe_Daruma();
	int rInfoEstendida_NFCe_Daruma(char* pszIndice, char* pszRetorno);
	int rRetornarInformacao_NFCe_Daruma(char* pszTipoIntervalo,char* pszInic, char* pszFim, char* pszSerie, char* pszChaveAcesso, char* pszInfoConsulta, char* pszResposta);
	int rRecuperarXML_NFCe_Daruma(char* pszDataInicial, char* pszDataFinal, char* pszStatusNF, char* pszPathXML);
	int rValidadeCertificado_NFCe_Daruma (char* pszDataVenc, char* pszDiasRestante);
	int rRetornarInformacaoArq_NFCe_Daruma(char* pszTipoIntervalo, char* pszInic, char* pszFim, char* pszSerie, char* pszChaveAcesso, char* pszInfoConsulta, char* pszPathArqResposta);
	int rURLQrcode_NFCe_Daruma(char* pszRetornoUrl);
	int rLeituraX_NFCe_Daruma(char* pszData, char* pszSerie, char* pszTipoRetorno, char* pszRetorno);
	int rStatusImpressora_NFCe_Daruma(void);

	//Metodos Especiais
	int eAjustarDataHora_NFCe_Daruma(void);
	int eAtualizarEnviarXML_NFCe_Daruma(char* pszPathXML, char* pszParametros, char* pszEnviaXML);
	int eEmiteOffline_NFCe_Daruma(char* pszOpcao);

	//Metodos de Contingencia
	int tEnviarContingenciaOffline_NFCe_Daruma(int iQtdDocsContingencia);
	int tEnviarContingenciaCancOffline_NFCe_Daruma(int iQtdDocsCancContingencia);
	int tEnvioUnitContingenciaOffline_NFCe_Daruma(char* pszCNPJEmit , char* pszSerie, char* psznNF, char* pszProtocolo, char* pszChaveAcesso, char* pszSitCodigo);
	int tEnvioUnitContingenciaCancOffline_NFCe_Daruma(char* pszCNPJEmit , char* pszSerie, char* psznNF, char* pszProtocolo, char* pszChaveAcesso, char* pszSitCodigo);
	int rNumDocsContingencia_NFCe_Daruma(void);
	int rNumDocsContingenciaCanc_NFCe_Daruma(void);
	int rRetornarInformacaoContingencia_NFCe_Daruma(char* pszChaveAcesso, char* pszNumNota, char* pszSerie, char* pszInfoConsulta, char* pszRetorno);
	int rUltimaCtg_NFCe_Daruma(char* pszUltimaCtg, char* pszTipoContingencia);
	int tEnvioUnitCtg_NFCe_Daruma(char* pszUltimaCtg, char* pszCNPJEmit, char* pszSerie, char* psznNF, char* pszProtocolo, char* pszChaveAcesso, char* pszSitCodigo);
	#pragma endregion	

	#pragma region TEF
	int tTransacaoCancelamentoTEF_NFCe_Daruma (char* pszDocFiscal, char*  pszValorTotal, char*  pszTipoIdentificacaoCliente, char*  pszIdentificacaoCliente, char* pszNSU, char* pszRedeAdquirente, char* pszDataComprovante, char* pszHoraComprovante, char*  pszInfoAdicional, char*  pszTaxaServico, char*  pszTipoCartao, char*  pszUsoFuturo);
	int tTransacaoAdministrativaTEF_NFCe_Daruma (char* pszDocFiscal, char*  pszTipoIdentificacaoCliente, char*  pszIdentificacaoCliente, char*  pszInfoAdicional, char*  pszTaxaServico, char*  pszTipoCartao, char*  pszUsoFuturo);
	#pragma endregion

	#pragma region NFE
	int tEnviar_NFe_Daruma(char* pszDocumentos, char* pszParametros, int iQtdeDoc, int iTipoRetorno, char* pszRetorno);
	#pragma endregion

	#pragma region GENERAL_METHODS

	int eBuscarPortaVelocidade_DUAL_DarumaFramework(void);
	int rStatusWS_NFCe_Daruma(void);
	int regAlterarValor_Daruma(char* pszPathChave, char* pszValor);
	int iImprimirTexto_DUAL_DarumaFramework(char* pszTexto, int iTamanhoTexto);

	#pragma endregion
