// ECF_MethodCall.cpp :
//

#include "stdafx.h"
#include <string.h>
#include <time.h>

int iReturn = 0;

void extendedReturns(int iMethodReturn) 
{
	char strReturn[300];_memset(strReturn);
    switch (iMethodReturn)
    {
		#pragma region RETURNS LIST NFCe
		case 0:
			memcpy(strReturn,"[0] - Erro encontrado",strlen("[0] - Erro encontrado"));
        break;
        case 1:
            memcpy(strReturn,"[1] - Comando executado com sucesso",strlen("[1] - Comando executado com sucesso"));
        break;
		case -1:
            memcpy(strReturn,"[-1] - Falha de comunicacao",strlen("[-1] - Falha de comunicacao"));
        break;
        case -2:
            memcpy(strReturn,"[-2] - Chave do desenvolvedor invalida",strlen("[-2] - Chave do desenvolvedor invalida"));
        break;
		case -3:
            memcpy(strReturn,"[-3] - Falha no schema XML",strlen("[-3] - Falha no schema XML"));
        break;
		case -4:
            memcpy(strReturn,"[-4] - XML Fora do padrao",strlen("[-4] - XML Fora do padro"));
        break;
		case -5:
            memcpy(strReturn,"[-5] - Erro generico",strlen("[-5] - Erro genrico"));
        break;
        case -135:
            memcpy(strReturn,"[-135] - NFCe nao em fase de encerramento",strlen("[-135] - NFCe nao em fase de encerramento"));
        break;
        case -134:
            memcpy(strReturn,"[-134] - NFCe nao em fase de pagamento",strlen("[-134] - NFCe nao em fase de pagamento"));
        break;
        case -133:
			memcpy(strReturn,"[-133] - NFCe nao em fase de totalizacao",strlen("[-133] - NFCe nao em fase de totalizacao"));
        break;
        case -132:
            memcpy(strReturn,"[-132] - NFCe nao em fase de venda",strlen("[-132] - NFCe nao em fase de venda"));
        break;
        case -131:
			memcpy(strReturn,"[-131] - NFCe nao esta aberta",strlen("[-131] - NFCe nao esta aberta"));
        break;
        case -130:
            memcpy(strReturn,"[-130] - NFCe ja esta aberta",strlen("[-130] - NFCe ja esta aberta"));
        break;
        case -99:
            memcpy(strReturn,"[-99] - Parametro invalido ou ponteiro nulo de parametro",strlen("[-99] - Parametro invalido ou ponteiro nulo de parametro"));
        break;
        case -52:
            memcpy(strReturn,"[-52] - Erro ao gravar em arquivo temporario de XML",strlen("[-52] - Erro ao gravar em arquivo temporario de XML"));
        break;
		case -40:
            memcpy(strReturn,"[-40] - Tag XML nao encontrada",strlen("[-40] - Tag XML nao encontrada"));
        break;
        default:
            memcpy(strReturn,"Erro desconhecido",strlen("Erro desconhecido"));
        break;
		#pragma endregion 
    }

    printf("Descricao => %s\n",strReturn);

	printf("-------------------------------------------------------------------------------\n");
	printf("=======================< Aguardando Proximo Comando >==========================\n\n");
		
}

void ConfigurationNFCe() 
{
	int i;

	char* option = (char*) malloc(sizeof(char*) * 200);
	char* aux1 = (char*) malloc(sizeof(char*) * 200);
	char* aux2 = (char*) malloc(sizeof(char*) * 200);
	
	static char* functions[] = 
	{
	    #pragma region FUNCTIONS LIST NFCe
		"Detectar MiniImpressora (Automatico)", //1
		"Configurar MiniImpressora (DUAL)",		//2
		"Configurar Chave Desenvolvedor",		//3
		"regAlterarValor_NFCe_Daruma",			//4
		"regRetornarValor_NFCe_Daruma"			//5
        #pragma endregion
	};

	for( ; ; ) 
	{
        Urmet();
		memset(aux1,0,sizeof(aux1));
		memset(aux2,0,sizeof(aux2));
		printf("\nMenu Principal -> Configuracao NFCe\n\n");

		for(i = 0; i < sizeof(functions) / sizeof(char*); i++) {
			printf("    [%s%d] - %s\n", i < 9 ? "0" : "", (i + 1), functions[i]);
		}

		printf("\n--------------------------------------------------------------------------");	
		printf("\nOBS: 0 para SAIR\n");
		printf("Escolha uma opcao para continuar: \n\n");	
		ler(option);

		if(!strcmp("0", option)) 
			break;

		switch(atoi(option)) 
		{
		    #pragma region 1 Detectar MiniImpressora (Automatico)
			case 1: 
			{
				iReturn = eBuscarPortaVelocidade_DUAL_DarumaFramework();
				printf("Retorno: %d\n", iReturn);
			}; break;
			#pragma endregion
            
            #pragma region  2 Configurar MiniImpressora (DUAL)
			case 2: 
			{
				printf("Porta/IP(ex> COM1 / 192.168.210.1:2000): ");
				ler(aux1);
				printf("Velocidade(ex> 9600, 115200): ");
				ler(aux2);

				iReturn = regAlterarValor_Daruma("DUAL\\PortaComunicacao", aux1);
				printf("Retorno: %d\n",iReturn = regAlterarValor_Daruma("DUAL\\Velocidade", aux2));
			}; break;
            #pragma endregion
            
            #pragma region 3 Configurar Chave Desenvolvedor
			case 3: 
			{
				printf("(Esta chave voce recebeu via email apos o cadastro)\n");
				printf(" http://simula.invoicy.com.br/cadastro.aspx\n");
				printf("Chave: ");
				ler(aux1);

				iReturn = regAlterarValor_NFCe_Daruma("CONFIGURACAO\\EmpPK", aux1);
				printf("Retorno: %d\n",iReturn);
			}; break;
            #pragma endregion

			#pragma region 4 regAlterarValor_NFCe_Daruma
			case 4: 
			{
				printf("Digite o path da chave: ");
				ler(aux1);
				printf("Digite o valor da chave: ");
				ler(aux2);

				iReturn = regAlterarValor_NFCe_Daruma(aux1, aux2);
				printf("Retorno: %d\n",iReturn);
			}; break;
            #pragma endregion

			#pragma region 5 regRetornarValor_NFCe_Daruma
			case 5: 
			{
				printf("Digite o caminho completo da tag que deseja consultar: ");
				ler(aux1);
				int iReturn = 0;

				iReturn = regRetornarValor_NFCe_Daruma(aux1,aux2);
				printf("Retorno Metodo: %d\n Informacao : %s\n",iReturn,aux2);
			}; break;
            #pragma endregion
            
			default: printf("Opcao invalida\n");
				printf("-------------------------------------------------------------------------------\n");
				printf("=======================< Aguardando Proximo Comando >==========================\n\n");
		}

		extendedReturns(iReturn);
		system("pause");
	}
	free(option);
	free(aux1);
	free(aux2);
}

void MethodsIssuance() 
{
	int i;

	char* option = (char*) malloc(sizeof(char*) * 2000);
	char* aux1 = (char*) malloc(sizeof(char*) * 102400);
	char* aux2 = (char*) malloc(sizeof(char*) * 2000);
	char* aux3 = (char*) malloc(sizeof(char*) * 200);
	char* aux4 = (char*) malloc(sizeof(char*) * 200);
	char* aux5 = (char*) malloc(sizeof(char*) * 102400);
	char* aux6 = (char*) malloc(sizeof(char*) * 200);
	char* aux7 = (char*) malloc(sizeof(char*) * 200);
	char* aux8 = (char*) malloc(sizeof(char*) * 200);
	char* aux9 = (char*) malloc(sizeof(char*) * 200);
	char* aux10 = (char*) malloc(sizeof(char*) * 200);
	char* aux11 = (char*) malloc(sizeof(char*) * 200);
	char* aux12 = (char*) malloc(sizeof(char*) * 200);
	char* aux13 = (char*) malloc(sizeof(char*) * 200);
	char* aux14 = (char*) malloc(sizeof(char*) * 200);

	static char* functions[] = 
	{
	    #pragma region FUNCTIONS LIST NFCe
		"aCFAbrir_NFCe_Daruma",							//1
		"aCFAbrirNumSerie_NFCe_Daruma",					//2
		"aCFConfImposto_NFCe_Daruma",					//3
		"aCFConfRastro_NFCe_Daruma",					//4
		"aCFConfICMS00_NFCe_Daruma",					//5
		"aCFConfICMS20_NFCe_Daruma",					//6
		"aCFConfICMS40_NFCe_Daruma",					//7
		"aCFConfICMS60_NFCe_Daruma",					//8
		"aCFConfICMS90_NFCe_Daruma",					//9
		"aCFConfICMSSN102_NFCe_Daruma",					//10
		"aCFConfICMSSN500_NFCe_Daruma",					//11
		"aCFConfICMSSN900_NFCe_Daruma",					//12
		"aCFConfPisAliq_NFCe_Daruma",					//13
		"aCFConfPisQtde_NFCe_Daruma",					//14
		"aCFConfPisNT_NFCe_Daruma",						//15
		"aCFConfPisOutr_NFCe_Daruma",					//16
		"aCFConfCofinsAliq_NFCe_Daruma",				//17
		"aCFConfCofinsQtde_NFCe_Daruma",				//18
		"aCFConfCofinsNT_NFCe_Daruma",					//19
		"aCFConfCofinsOutr_NFCe_Daruma",				//20
		"aCFValorLeiImposto_NFCe_Daruma",				//21
		"aCFConfLeiImposto_NFCe_Daruma",				//22
		"aCFConfCombustivel_NFCe_Daruma",				//23
		"aCFVender_NFCe_Daruma",						//24
		"aCFVenderCompleto_NFCe_Daruma",				//25
		"aCFVenderXml_NFCe_Daruma",						//26
		"aCFLancarAcrescimoItem_NFCe_Daruma",			//27
		"aCFLancarDescontoItem_NFCe_Daruma",			//28
		"aCFCancelarAcrescimoItem_NFCe_Daruma",			//29
		"aCFCancelarDescontoItem_NFCe_Daruma",			//30
		"aCFCancelarItemParcial_NFCe_Daruma",			//31
		"aCFCancelarItem_NFCe_Daruma",					//32
		"aCFTotalizar_NFCe_Daruma",						//33
		"aCFIdentificarCartao_NFCe_Daruma",				//34
		"aCFEfetuarPagamento_NFCe_Daruma",				//35
		"aCFEfetuarPagamentoCartao_NFCe_Daruma",		//36
		"aCFEstornarPagamento_NFCe_Daruma",				//37
		"aCFIdentificarConsumidor_NFCe_Daruma",			//38
		"aCFIdentificarTransportadora_NFCe_Daruma",		//39
		"aCFMsgPromocional_NFCe_Daruma",				//40
		"tCFEncerrar_NFCe_Daruma",						//41
		"tCFEncerrarConfigMsg_NFCe_Daruma",				//42
		"tCFCancelar_NFCe_Daruma",						//43
		"tCFCancelarParametrizado_NFCe_Daruma",			//44
		"tCFInutilizar_NFCe_Daruma",					//45
		"tDescartarNota_NFCe_Daruma",					//46
		"iCFImprimir_NFCe_Daruma",						//47
		"iCFImprimirParametrizado_NFCe_Daruma",			//48
		"iCFReImprimir_NFCe_Daruma",					//49
		"iTEFImprimirResposta_NFCe_Daruma",				//50
		"eAtualizarEnviarXML_NFCe_Daruma",				//51
		"eEmiteOffline_NFCe_Daruma",					//52
		"eAjustarDataHora_NFCe_Daruma",					//53
		"tCFCancelarOffline_NFCe_Daruma",				//54
		"tEnviarContingenciaOffline_NFCe_Daruma",		//55
		"tEnviarContingenciaCancOffline_NFCe_Daruma",	//56
		"rNumDocsContingencia_NFCe_Daruma",				//57
		"rNumDocsContingenciaCanc_NFCe_Daruma",			//58
		"rRetornarInformacaoContingencia_NFCe_Daruma",	//59
		"tEnvioUnitContingenciaOffline_NFCe_Daruma",	//60
		"tEnvioUnitContingenciaCancOffline_NFCe_Daruma",//61
		"rUltimaCtg_NFCe_Daruma",						//62
		"tEnvioUnitCtg_NFCe_Daruma",					//63
		"tTransacaoAdministrativaTEF_NFCe_Daruma",		//64
		"tTransacaoCancelamentoTEF_NFCe_Daruma",		//65
		"tEnviar_NFe_Daruma"							//66

        #pragma endregion
	};

	for( ; ; ) 
	{
        Urmet();
		printf("\nMenu Principal -> Emissao NFCe\n\n");

		memset(aux1,0,sizeof(aux1));
		memset(aux2,0,sizeof(aux2));
		memset(aux3,0,sizeof(aux3));
		memset(aux4,0,sizeof(aux4));
		memset(aux5,0,sizeof(aux5));
		memset(aux6,0,sizeof(aux6));
		memset(aux7,0,sizeof(aux7));
		memset(aux8,0,sizeof(aux8));
		memset(aux9,0,sizeof(aux9));
		memset(aux10,0,sizeof(aux10));
		memset(aux11,0,sizeof(aux11));
		memset(aux12,0,sizeof(aux12));
		memset(aux13,0,sizeof(aux13));
		memset(aux14,0,sizeof(aux14));

		for(i = 0; i < sizeof(functions) / sizeof(char*); i++) {
			printf("    [%s%d] - %s\n", i < 9 ? "0" : "", (i + 1), functions[i]);
		}

		printf("\n--------------------------------------------------------------------------");	
		printf("Parametros Obrigatorios estao indicados com *\n");
		printf("\nOBS: 0 para SAIR\n");
		printf("Escolha uma opcao para continuar: \n\n");	
		ler(option);

		if(!strcmp("0", option)) 
			break;

		switch(atoi(option)) 
		{
		    #pragma region 1 aCFAbrir_NFCe_Daruma
			case 1: 
			{
				printf("CPF: ");
				ler(aux1);
				printf("Nome: ");
				ler(aux2);
				printf("Logradouro: ");
				ler(aux3);
				printf("Numero: ");
				ler(aux4);
				printf("Bairro: ");
				ler(aux5);
				printf("Codigo: ");
				ler(aux6);
				printf("Municipio: ");
				ler(aux7);
				printf("UF: ");
				ler(aux8);
				printf("CEP: ");
				ler(aux9);

				iReturn = aCFAbrir_NFCe_Daruma(aux1, aux2, aux3, aux4, aux5, aux6, aux7, aux8, aux9);
				printf("Retorno: %d\n", iReturn);
			}; break;
			#pragma endregion

			#pragma region 2 aCFAbrirNumSerie_NFCe_Daruma
			case 2: 
			{
				printf("Numero NFCe: ");
				ler(aux1);
				printf("Serie: ");
				ler(aux2);
				printf("CPF/CNPJ: ");
				ler(aux3);
				printf("Nome: ");
				ler(aux4);
				printf("Logradouro: ");
				ler(aux5);
				printf("Numero: ");
				ler(aux6);
				printf("Bairro: ");
				ler(aux7);
				printf("Codigo: ");
				ler(aux8);
				printf("Municipio: ");
				ler(aux9);
				printf("UF: ");
				ler(aux10);
				printf("CEP: ");
				ler (aux11);

				iReturn = aCFAbrirNumSerie_NFCe_Daruma(aux1, aux2, aux3, aux4, aux5, aux6, aux7, aux8, aux9, aux10, aux11);
				printf("Retorno: %d\n", iReturn);
		}; break;
        #pragma endregion

		#pragma region 3 aCFConfImposto_NFCe_Daruma
		case 3: 
		{
			printf("Nome do imposto: ");
			ler(aux1);
			printf("Parametros: ");
			ler(aux2);

			iReturn = aCFConfImposto_NFCe_Daruma(aux1, aux2);
			printf("Retorno: %d\n",iReturn);
		}; break;
		#pragma endregion

		#pragma region 4 aCFConfRastro_NFCe_Daruma
		case 4: 
		{
			printf("Parametros: ");
			ler(aux1);

			iReturn = aCFConfRastro_NFCe_Daruma(aux1);
			printf("Retorno: %d\n",iReturn);

		}; break;
		#pragma endregion

		#pragma region 5 aCFConfICMS00_NFCe_Daruma
		case 5: 
		{
			printf("Origem da Mercadoria: ");
			ler(aux1);
			printf("CST: ");
			ler(aux2);
			printf("Modalidade: ");
			ler(aux3);
			printf("Aliquota: ");
			ler(aux4);

			iReturn = aCFConfICMS00_NFCe_Daruma(aux1,aux2,aux3,aux4);
			printf("Retorno: %d\n",iReturn);

		}; break;
		#pragma endregion

		#pragma region 6 aCFConfICMS20_NFCe_Daruma
		case 6: 
		{
			printf("Origem da Mercadoria: ");
			ler(aux1);
			printf("CST: ");
			ler(aux2);
			printf("ModBC: ");
			ler(aux3);
			printf("pRedBC: ");
			ler(aux4);
			printf("pICMS: ");
			ler(aux5);

			iReturn = aCFConfICMS20_NFCe_Daruma(aux1,aux2,aux3,aux4,aux5);
			printf("Retorno: %d\n",iReturn);

		}; break;
		#pragma endregion
        
		#pragma region 7 aCFConfICMS40_NFCe_Daruma
		case 7: 
		{
			printf("Origem da Mercadoria: ");
			ler(aux1);
			printf("CST: ");
			ler(aux2);
			printf("Valor do ICMS: ");
			ler(aux3);
			printf("Motivo da desoneracao: ");
			ler(aux4);

			iReturn = aCFConfICMS40_NFCe_Daruma(aux1,aux2,aux3,aux4);
			printf("Retorno: %d\n",iReturn);

		}; break;
		#pragma endregion

		#pragma region 8 aCFConfICMS60_NFCe_Daruma
		case 8: 
		{
			printf("Origem da Mercadoria: ");
			ler(aux1);
			printf("CST: ");
			ler(aux2);
			printf("Valor da Base de Calculo: ");
			ler(aux3);
			printf("Motivo do ICMS ST Retido: ");
			ler(aux4);

			iReturn = aCFConfICMS60_NFCe_Daruma(aux1,aux2,aux3,aux4);
			printf("Retorno: %d\n",iReturn);

		}; break;
		#pragma endregion

		#pragma region 9 aCFConfICMS90_NFCe_Daruma
		case 9: 
		{
			printf("Origem da Mercadoria: ");
			ler(aux1);
			printf("CST: ");
			ler(aux2);
			printf("ModBC: ");
			ler(aux3);
			printf("pRedBC: ");
			ler(aux4);
			printf("pICMS: ");
			ler(aux5);
			printf("ModBCST: ");
			ler(aux6);
			printf("pMVAST: ");
			ler(aux7);
			printf("pRedBCST: ");
			ler(aux8);
			printf("vBCST: ");
			ler(aux9);
			printf("pICMSST: ");
			ler(aux10);
			printf("vICMSDeson: ");
			ler(aux11);
			printf("motDesICMS: ");
			ler(aux12);

			iReturn = aCFConfICMS90_NFCe_Daruma(aux1,aux2,aux3,aux4,aux5,aux9,aux7,aux8,aux9,aux10,aux11,aux12);
			printf("Retorno: %d\n",iReturn);

		}; break;
		#pragma endregion

		#pragma region 10 aCFConfICMSSN102_NFCe_Daruma
		case 10: 
		{
			printf("Origem da Mercadoria: ");
			ler(aux1);
			printf("CSOSN: ");
			ler(aux2);

			iReturn = aCFConfICMSSN102_NFCe_Daruma(aux1,aux2);
			printf("Retorno: %d\n",iReturn);

		}; break;
		#pragma endregion

		#pragma region 11 aCFConfICMSSN500_NFCe_Daruma
		case 11: 
		{
			printf("Origem da Mercadoria: ");
			ler(aux1);
			printf("CSOSN: ");
			ler(aux2);
			printf("Valor da Base de Calculo: ");
			ler(aux3);
			printf("Valor do ICMS ST Retido: ");
			ler(aux4);
				
			iReturn = aCFConfICMSSN500_NFCe_Daruma(aux1,aux2,aux3,aux4);
			printf("Retorno: %d\n",iReturn);

		}; break;
		#pragma endregion

		#pragma region 12 aCFConfICMSSN900_NFCe_Daruma
		case 12: 
		{
			printf("Origem da Mercadoria: ");
			ler(aux1);
			printf("CSOSN: ");
			ler(aux2);
			printf("ModBC: ");
			ler(aux3);
			printf("pRedBC: ");
			ler(aux4);
			printf("pICMS: ");
			ler(aux5);
			printf("ModBCST: ");
			ler(aux6);
			printf("pMVAST: ");
			ler(aux7);
			printf("pRedBCST: ");
			ler(aux8);
			printf("vBCST: ");
			ler(aux9);
			printf("pICMSST: ");
			ler(aux10);
			printf("vICMSST: ");
			ler(aux11);
			printf("vICMSDeson: ");
			ler(aux12);
			printf("motDesICMS: ");
			ler(aux13);

			iReturn = aCFConfICMSSN900_NFCe_Daruma(aux1,aux2,aux3,aux4,aux5,aux9,aux7,aux8,aux9,aux10,aux11,aux12,aux13);
			printf("Retorno: %d\n",iReturn);

		}; break;
		#pragma endregion

		#pragma region 13 aCFConfPisAliq_NFCe_Daruma
		case 13: 
		{
			printf("CST: ");
			ler(aux1);
			printf("pPIS: ");
			ler(aux2);

			iReturn = aCFConfPisAliq_NFCe_Daruma(aux1,aux2);
			printf("Retorno: %d\n",iReturn);

		}; break;
		#pragma endregion

		#pragma region 14 aCFConfPisQtde_NFCe_Daruma
		case 14: 
		{
			printf("CST: ");
			ler(aux1);
			printf("vAliqProd: ");
			ler(aux2);

			iReturn = aCFConfPisQtde_NFCe_Daruma(aux1,aux2);
			printf("Retorno: %d\n",iReturn);

		}; break;
		#pragma endregion

		#pragma region 15 aCFConfPisNT_NFCe_Daruma
		case 15: 
		{
			printf("CST: ");
			ler(aux1);

			iReturn = aCFConfPisNT_NFCe_Daruma(aux1);
			printf("Retorno: %d\n",iReturn);

		}; break;
		#pragma endregion

		#pragma region 16 aCFConfPisOutr_NFCe_Daruma
		case 16: 
		{
			printf("CST: ");
			ler(aux1);
			printf("pPIS: ");
			ler(aux2);
			printf("vAliqProd: ");
			ler(aux3);

			iReturn = aCFConfPisOutr_NFCe_Daruma(aux1,aux2,aux3);
			printf("Retorno: %d\n",iReturn);

		}; break;
		#pragma endregion

		#pragma region 17 aCFConfCofinsAliq_NFCe_Daruma
		case 17: 
		{
			printf("CST: ");
			ler(aux1);
			printf("pCOFINS: ");
			ler(aux2);

			iReturn = aCFConfCofinsAliq_NFCe_Daruma(aux1,aux2);
			printf("Retorno: %d\n",iReturn);

		}; break;
		#pragma endregion

		#pragma region 18 aCFConfCofinsQtde_NFCe_Daruma
		case 18: 
		{
			printf("CST: ");
			ler(aux1);
			printf("vAliqProd: ");
			ler(aux2);

			iReturn = aCFConfCofinsQtde_NFCe_Daruma(aux1,aux2);
			printf("Retorno: %d\n",iReturn);

		}; break;
		#pragma endregion

		#pragma region 19 aCFConfCofinsNT_NFCe_Daruma
		case 19: 
		{
			printf("CST: ");
			ler(aux1);

			iReturn = aCFConfCofinsNT_NFCe_Daruma(aux1);
			printf("Retorno: %d\n",iReturn);

		}; break;
		#pragma endregion

		#pragma region 20 aCFConfCofinsOutr_NFCe_Daruma
		case 20: 
		{
			printf("CST: ");
			ler(aux1);
			printf("pCOFINS: ");
			ler(aux2);
			printf("vAliqProd: ");
			ler(aux3);

			iReturn = aCFConfCofinsOutr_NFCe_Daruma(aux1,aux2,aux3);
			printf("Retorno: %d\n",iReturn);

		}; break;
		#pragma endregion

		#pragma region 21 aCFValorLeiImposto_NFCe_Daruma
		case 21: 
		{
			printf("Digite o valor do imposto ja na formatacao que sera impresso: ");
			ler(aux1);

			iReturn = aCFValorLeiImposto_NFCe_Daruma(aux1);
			printf("Retorno: %d\n",iReturn);

		}; break;
		#pragma endregion
		
		#pragma region 22 aCFConfLeiImposto_NFCe_Daruma
		case 22: 
		{
			printf("NCM: ");
			ler(aux1);
			printf("Ex: ");
			ler(aux2);
			printf("Tipo: ");
			ler(aux3);
			printf("NacionalFed: ");
			ler(aux4);
			printf("ImportadoFed: ");
			ler(aux5);
			printf("Estadual: ");
			ler(aux6);
			printf("Mun: ");
			ler(aux7);

			iReturn = aCFConfLeiImposto_NFCe_Daruma(aux1,aux2,aux3,aux4,aux5,aux6,aux7);
			printf("Retorno: %d\n",iReturn);

		}; break;
		#pragma endregion

		#pragma region 23 aCFConfCombustivel_NFCe_Daruma
		case 23: 
		{
			printf("cProdANP: ");
			ler(aux1);
			printf("pMixGN: ");
			ler(aux2);
			printf("CODIF: ");
			ler(aux3);
			printf("qTemp: ");
			ler(aux4);
			printf("UFCons: ");
			ler(aux5);
			printf("qBCProd: ");
			ler(aux6);
			printf("vAliqProd: ");
			ler(aux7);
			printf("vCIDE: ");
			ler(aux8);
			printf("nBico: ");
			ler(aux9);
			printf("nBomba: ");
			ler(aux10);
			printf("nTanque: ");
			ler(aux11);
			printf("vEncInicial: ");
			ler(aux12);
			printf("vEncFinal: ");
			ler(aux13);
			printf("Uso Futuro: ");
			ler(aux14);

			iReturn = aCFConfCombustivel_NFCe_Daruma(aux1,aux2,aux3,aux4,aux5,aux6,aux7,aux8,aux9,aux10,aux11,aux12,aux13,aux14);
			printf("Retorno: %d\n",iReturn);

		}; break;
		#pragma endregion

        #pragma region 24 aCFVender_NFCe_Daruma
		case 24: 
		{
			printf("Aliquota: ");
			ler(aux1);
			printf("Quantidade: ");
			ler(aux2);
			printf("Valor Unitario: ");
			ler(aux3);
			printf("Tipo Desc./Acresc.: ");
			ler(aux4);
			printf("Valor Desc./Acresc.: ");
			ler(aux5);
			printf("Codigo Item: ");
			ler(aux6);
			printf("Unidade de Medida: ");
			ler(aux7);
			printf("Descricao: ");
			ler(aux8);

			iReturn = aCFVender_NFCe_Daruma(aux1, aux2, aux3, aux4, aux5, aux6, aux7, aux8);
			printf("Retorno: %d\n",iReturn);

		}; break;
        #pragma endregion

		#pragma region 25 aCFVenderCompleto_NFCe_Daruma
		case 25: 
		{
			printf("Aliquota: ");
			ler(aux1);
			printf("Quantidade: ");
			ler(aux2);
			printf("Valor Unitario: ");
			ler(aux3);
			printf("Tipo Desc./Acresc.: ");
			ler(aux4);
			printf("Valor Desc./Acresc.: ");
			ler(aux5);
			printf("Codigo Item: ");
			ler(aux6);
			printf("NCM: ");
			ler(aux7);
			printf("CFOP: ");
			ler(aux8);
			printf("Unidade de Medida: ");
			ler(aux9);
			printf("Descricao: ");
			ler(aux10);
			printf("Uso Futuro: ");
			ler(aux11);

			iReturn = aCFVenderCompleto_NFCe_Daruma(aux1, aux2, aux3, aux4, aux5, aux6, aux7, aux8,aux9,aux10,aux11);
			printf("Retorno: %d\n",iReturn);

		}; break;
        #pragma endregion

		#pragma region 26 aCFVenderXml_NFCe_Daruma
		case 26: 
		{
			printf("XML: ");
			ler(aux1);

			iReturn = aCFVenderXml_NFCe_Daruma(aux1);
			printf("Retorno: %d\n",iReturn);

		}; break;
        #pragma endregion

		#pragma region 27 aCFLancarAcrescimoItem_NFCe_Daruma
		case 27: 
		{
			printf("Numero Item: ");
			ler(aux1);
			printf("Tipo Acrescimo: ");
			ler(aux2);
			printf("Valor Acrescimo: ");
			ler(aux3);

			iReturn = aCFLancarAcrescimoItem_NFCe_Daruma(aux1, aux2, aux3);
			printf("Retorno: %d\n",iReturn);

		}; break;
        #pragma endregion

		#pragma region 28 aCFLancarDescontoItem_NFCe_Daruma
		case 28: 
		{
			printf("Numero Item: ");
			ler(aux1);
			printf("Tipo Desconto: ");
			ler(aux2);
			printf("Valor Desconto: ");
			ler(aux3);

			iReturn = aCFLancarDescontoItem_NFCe_Daruma(aux1, aux2, aux3);
			printf("Retorno: %d\n",iReturn);

		}; break;
        #pragma endregion

		#pragma region 29 aCFCancelarAcrescimoItem_NFCe_Daruma
		case 29: 
		{
			printf("Digite o Numero do Item: ");
			ler(aux1);

			iReturn = aCFCancelarAcrescimoItem_NFCe_Daruma(aux1);
			printf("Retorno: %d\n",iReturn);

		}; break;
        #pragma endregion

		#pragma region 30 aCFCancelarDescontoItem_NFCe_Daruma
		case 30: 
		{
			printf("Digite o Numero do Item: ");
			ler(aux1);

			iReturn = aCFCancelarDescontoItem_NFCe_Daruma(aux1);
			printf("Retorno: %d\n",iReturn);

		}; break;
        #pragma endregion

		#pragma region 31 aCFCancelarItemParcial_NFCe_Daruma
		case 31: 
		{
			printf("Numero Item: ");
			ler(aux1);
			printf("Quantidade: ");
			ler(aux2);

			iReturn = aCFCancelarItemParcial_NFCe_Daruma(aux1, aux2);
			printf("Retorno: %d\n",iReturn);

		}; break;
        #pragma endregion

		#pragma region 32 aCFCancelarItem_NFCe_Daruma
		case 32: 
		{
			printf("Digite o Numero do Item: ");
			ler(aux1);

			iReturn = aCFCancelarItem_NFCe_Daruma(aux1);
			printf("Retorno: %d\n",iReturn);

		}; break;
        #pragma endregion
            
        #pragma region 33 aCFTotalizar_NFCe_Daruma
		case 33: 
		{
			printf("Tipo Desc./Acresc.: ");
			ler(aux1);
			printf("Valor Desc./Acresc.: ");
			ler(aux2);

			iReturn = aCFTotalizar_NFCe_Daruma(aux1, aux2);
			printf("Retorno: %d\n",iReturn);

		}; break;
        #pragma endregion

		#pragma region 34 aCFIdentificarCartao_NFCe_Daruma
		case 34: 
		{
			printf("CNPJ: ");
			ler(aux1);
			printf("Bandeira: ");
			ler(aux2);
			printf("Num. de Autorizacao: ");
			ler(aux3);

			iReturn = aCFIdentificarCartao_NFCe_Daruma(aux1, aux2,aux3);
			printf("Retorno: %d\n",iReturn);

		}; break;
        #pragma endregion

		#pragma region 35 aCFEfetuarPagamento_NFCe_Daruma
		case 35: 
		{
			printf("Forma de Pagamento: ");
			ler(aux1);
			printf("Valor: ");
			ler(aux2);

			iReturn = aCFEfetuarPagamento_NFCe_Daruma(aux1, aux2);
			printf("Retorno: %d\n",iReturn);

		}; break;
        #pragma endregion

		#pragma region 36 aCFEfetuarPagamentoCartao_NFCe_Daruma
		case 36: 
		{
			printf("Tipo Cartao: ");
			ler(aux1);
			printf("Valor Pagamento: ");
			ler(aux2);
			printf("Tipo da Integracao: ");
			ler(aux3);
			printf("CNPJCred: ");
			ler(aux4);
			printf("Cod. da Bandeira: ");
			ler(aux5);
			printf("Num. da Autorizacao: ");
			ler(aux6);
			printf("Uso Futuro: ");
			ler(aux7);

			iReturn = aCFEfetuarPagamentoCartao_NFCe_Daruma(aux1, aux2,aux3,aux4,aux5,aux6,aux7);
			printf("Retorno: %d\n",iReturn);

		}; break;
        #pragma endregion

		#pragma region 37 aCFEstornarPagamento_NFCe_Daruma
		case 37: 
		{
			printf("Forma Pagamento Estornada: ");
			ler(aux1);
			printf("Forma Pagamento Efetivada: ");
			ler(aux2);
			printf("Valor: ");
			ler(aux3);

			iReturn = aCFEstornarPagamento_NFCe_Daruma(aux1, aux2, aux3);
			printf("Retorno: %d\n",iReturn);

		}; break;
        #pragma endregion

		#pragma region 38 aCFIdentificarConsumidor_NFCe_Daruma
		case 38: 
		{
			printf("CPF: ");
			ler(aux1);
			printf("Nome: ");
			ler(aux2);
			printf("Logradouro: ");
			ler(aux3);
			printf("Numero: ");
			ler(aux4);
			printf("Bairro: ");
			ler(aux5);
			printf("Cod. Municipio: ");
			ler(aux6);
			printf("Municipio: ");
			ler(aux7);
			printf("UF: ");
			ler(aux8);
			printf("CEP: ");
			ler(aux9);
			printf("Email: ");
			ler(aux10);

			iReturn = aCFIdentificarConsumidor_NFCe_Daruma(aux1, aux2, aux3,aux4,aux5,aux6,aux7,aux8,aux9,aux10);
			printf("Retorno: %d\n",iReturn);

		}; break;
        #pragma endregion

		#pragma region 39 aCFIdentificarTransportadora_NFCe_Daruma
		case 39: 
		{
			printf("CPF/CNPJ: ");
			ler(aux1);
			printf("Nome: ");
			ler(aux2);
			printf("IE: ");
			ler(aux3);
			printf("Endereco: ");
			ler(aux4);
			printf("Municipio: ");
			ler(aux5);
			printf("UF: ");
			ler(aux6);

			iReturn = aCFIdentificarTransportadora_NFCe_Daruma(aux1,aux2,aux3,aux4,aux5,aux6);
			printf("Retorno: %d\n",iReturn);

		}; break;
        #pragma endregion

		#pragma region 40 aCFMsgPromocional_NFCe_Daruma
		case 40: 
		{
			printf("Mensagem Promocional: ");
			ler(aux1);
			printf("Texto Livre: ");
			ler(aux2);

			iReturn = aCFMsgPromocional_NFCe_Daruma(aux1,aux2);
			printf("Retorno: %d\n",iReturn);

		}; break;
        #pragma endregion
		
		#pragma region 41 tCFEncerrar_NFCe_Daruma
		case 41: 
		{
			printf("Mensagem Promocional: ");
			ler(aux1);

			iReturn = tCFEncerrar_NFCe_Daruma(aux1);
			printf("Retorno: %d\n",iReturn);

		}; break;
        #pragma endregion

		#pragma region 42 tCFEncerrarConfigMsg_NFCe_Daruma
		case 42: 
		{
			printf("Mensagem Promocional: ");
			ler(aux1);
			printf("Mensagem Destinada ao Fisco: ");
			ler(aux2);
			printf("Uso Futuro: ");
			ler(aux3);

			iReturn = tCFEncerrarConfigMsg_NFCe_Daruma(aux1,aux2,aux3);
			printf("Retorno: %d\n",iReturn);

		}; break;
        #pragma endregion

		#pragma region 43 tCFCancelar_NFCe_Daruma
		case 43: 
		{
			printf("Numero da Nota Fiscal: ");
			ler(aux1);
			printf("Numero de Serie: ");
			ler(aux2);
			printf("Chave de Acesso: ");
			ler(aux3);
			printf("Protocolo de Autorizacao: ");
			ler(aux4);
			printf("Justificativa: ");
			ler(aux5);

			iReturn = tCFCancelar_NFCe_Daruma(aux1, aux2, aux3, aux4, aux5);
			printf("Retorno: %d\n",iReturn);

		}; break;
        #pragma endregion

		#pragma region 44 tCFCancelarParametrizado_NFCe_Daruma
		case 44: 
		{
			printf("Numero da Nota Fiscal: ");
			ler(aux1);
			printf("Numero de Serie: ");
			ler(aux2);
			printf("Chave de Acesso: ");
			ler(aux3);
			printf("Protocolo de Autorizacao: ");
			ler(aux4);
			printf("Justificativa: ");
			ler(aux5);
			printf("Parametros: ");
			ler(aux6);

			iReturn = tCFCancelarParametrizado_NFCe_Daruma(aux1, aux2, aux3, aux4, aux5,aux6);
			printf("Retorno: %d\n",iReturn);

		}; break;
        #pragma endregion

		#pragma region 45 tCFInutilizar_NFCe_Daruma
		case 45: 
		{
			printf("Num. da Nota/Inicio do Intervalo: ");
			ler(aux1);
			printf("Num. da Nota/Final do Intervalo: ");
			ler(aux2);
			printf("Num. da Serie: ");
			ler(aux3);
			printf("Justificativa: ");
			ler(aux4);

			iReturn = tCFInutilizar_NFCe_Daruma(aux1, aux2, aux3, aux4);
			printf("Retorno: %d\n",iReturn);

		}; break;
        #pragma endregion

		#pragma region 46 tDescartarNota_NFCe_Daruma
		case 46: 
		{
			printf("Num. da Nota: ");
			ler(aux1);
			printf("Num. da Serie: ");
			ler(aux2);
			printf("Opcao: ");
			ler(aux3);

			iReturn = tDescartarNota_NFCe_Daruma(aux1, aux2, aux3);
			printf("Retorno: %d\n",iReturn);

		}; break;
        #pragma endregion

		#pragma region 47 iCFImprimir_NFCe_Daruma
		case 47: 
		{
			printf("Caminho do xml de envio: ");
			ler(aux1);
			printf("Caminho do xml de retorno: ");
			ler(aux2);
			printf("Link para QrCode (se vazio, captura link no XML): ");
			ler(aux3);
			printf("Numero de colunas Impressora: ");
			ler(aux4);
			int iaux4 = atoi(aux4);
			printf("Tipo NF: ");
			ler(aux5);
			int iaux5 = atoi(aux5);

			iReturn = iCFImprimir_NFCe_Daruma(aux1, aux2, aux3,iaux4,iaux5);
			printf("Retorno: %d\n",iReturn);

		}; break;
        #pragma endregion
		
		#pragma region 48 iCFImprimirParametrizado_NFCe_Daruma
		case 48: 
		{
			printf("Caminho do xml de envio: ");
			ler(aux1);
			printf("Caminho do xml de retorno: ");
			ler(aux2);
			printf("Link para QrCode (se vazio, captura link no XML): ");
			ler(aux3);
			printf("Numero de colunas Impressora: ");
			ler(aux4);
			int iaux4 = atoi(aux4);
			printf("Tipo NF: ");
			ler(aux5);
			int iaux5 = atoi(aux5);
			printf("Parametros: ");
			ler(aux6);

			iReturn = iCFImprimirParametrizado_NFCe_Daruma(aux1, aux2, aux3,iaux4,iaux5,aux6);
			printf("Retorno: %d\n",iReturn);

		}; break;
        #pragma endregion

		#pragma region 49 iCFReImprimir_NFCe_Daruma
		case 49: 
		{
			printf("Num. da Nota: ");
			ler(aux1);
			printf("Serie: ");
			ler(aux2);
			printf("Chave de Acesso: ");
			ler(aux3);

			iReturn = iCFReImprimir_NFCe_Daruma(aux1, aux2, aux3);
			printf("Retorno: %d\n",iReturn);

		}; break;
        #pragma endregion

		#pragma region 50 iTEFImprimirResposta_NFCe_Daruma
		case 50: 
		{
			printf("Diretorio e nome do arquivo de Resposta: ");
			ler(aux1);
			printf("Numero de vias para impressao: ");
			ler(aux2);
			int iaux2 = atoi(aux2);
			printf("Corte entre Vias (0= Corte Total / 1 = Corte Parcial / 2 = Sem Corte): ");
			ler(aux3);
			int iaux3 = atoi(aux3);
			printf("Travar Teclaro (1 = Trava teclado / 0 = Nao Trava Teclado): ");
			ler(aux4);
			int iaux4 = atoi(aux4);

			iReturn = iTEFImprimirResposta_NFCe_Daruma(aux1, iaux2, iaux3,iaux4);
			printf("Retorno: %d\n",iReturn);

		}; break;
        #pragma endregion

		#pragma region 51 eAtualizarEnviarXML_NFCe_Daruma
		case 51: 
		{
			printf("Caminho do XML para alteracao: ");
			ler(aux1);
			printf("Parametro a ser alterado: ");
			ler(aux2);
			printf("Envio de XML(0 - Atualiza XML / 1 - Atualiza/EnviaXML): ");
			ler(aux3);

			iReturn = eAtualizarEnviarXML_NFCe_Daruma(aux1,aux2,aux3);
			printf("Retorno: %d\n",iReturn);

		}; break;
        #pragma endregion

		#pragma region 52 eEmiteOffline_NFCe_Daruma
		case 52: 
		{
			printf("Opcao: ");
			ler(aux1);

			iReturn = eEmiteOffline_NFCe_Daruma(aux1);
			printf("Retorno: %d\n",iReturn);

		}; break;
        #pragma endregion

		#pragma region 53 eAjustarDataHora_NFCe_Daruma
		case 53: 
		{
			iReturn = eAjustarDataHora_NFCe_Daruma();
			printf("Retorno: %d\n",iReturn);

		}; break;
        #pragma endregion

		#pragma region 54 tCFCancelarOffline_NFCe_Daruma
		case 54: 
		{
			printf("Num. da Nota Fiscal: ");
			ler(aux1);
			printf("Num. da Serie: ");
			ler(aux2);
			printf("Chave de Acesso: ");
			ler(aux3);
			printf("Justificativa: ");
			ler(aux4);

			iReturn = tCFCancelarOffline_NFCe_Daruma(aux1,aux2,aux3,aux4);
			printf("Retorno: %d\n",iReturn);

		}; break;
        #pragma endregion

		#pragma region 55 tEnviarContingenciaOffline_NFCe_Daruma
		case 55: 
		{
			printf("Informe a quantidade de arquivos que deseja enviar (se 0, envia todos os arquivos): ");
			ler(aux1);
			int iaux1 = atoi(aux1);

			iReturn = tEnviarContingenciaOffline_NFCe_Daruma(iaux1);
			printf("Retorno: %d\n",iReturn);

		}; break;
        #pragma endregion

		#pragma region 56 tEnviarContingenciaCancOffline_NFCe_Daruma
		case 56: 
		{
			printf("Informe a quantidade de arquivos cancelados que deseja enviar (se 0, envia todos os arquivos): ");
			ler(aux1);
			int iaux1 = atoi(aux1);

			iReturn = tEnviarContingenciaCancOffline_NFCe_Daruma(iaux1);
			printf("Retorno: %d\n",iReturn);

		}; break;
        #pragma endregion

		#pragma region 57 rNumDocsContingencia_NFCe_Daruma
		case 57: 
		{
			iReturn = rNumDocsContingencia_NFCe_Daruma();
			printf("Quantidade de Arquivos de Venda: %d\n",iReturn);

		}; break;
        #pragma endregion

		#pragma region 58 rNumDocsContingenciaCanc_NFCe_Daruma
		case 58: 
		{
			iReturn = rNumDocsContingenciaCanc_NFCe_Daruma();
			printf("Quantidade de Arquivos de Cancelamento: %d\n",iReturn);

		}; break;
        #pragma endregion

		#pragma region 59 rRetornarInformacaoContingencia_NFCe_Daruma
		case 59: 
		{	
			char StrRetorno[1024*100]; memset(StrRetorno,0,sizeof(StrRetorno));
			printf("Chave de Acesso: ");
			ler(aux1);
			printf("Nota: ");
			ler(aux2);
			printf("Serie: ");
			ler(aux3);
			printf("Indice: ");
			ler(aux4);

			iReturn = rRetornarInformacaoContingencia_NFCe_Daruma(aux1, aux2, aux3, aux4,StrRetorno);
			printf("\nRetorno do metodo: %d\n", iReturn);
			printf("Retorno da Variavel: %s \n", StrRetorno);
		}; break;
        #pragma endregion

		#pragma region 60 tEnvioUnitContingenciaOffline_NFCe_Daruma
		case 60: 
		{	
			char StrRetornoCNPJ[15]; memset(StrRetornoCNPJ,0,sizeof(StrRetornoCNPJ));
			char StrRetornoSerie[4]; memset(StrRetornoSerie,0,sizeof(StrRetornoSerie));
			char StrRetornoNumNota[10]; memset(StrRetornoNumNota,0,sizeof(StrRetornoNumNota));
			char StrRetornoProtocolo[41]; memset(StrRetornoProtocolo,0,sizeof(StrRetornoProtocolo));
			char StrRetornoChaveAcesso[45]; memset(StrRetornoChaveAcesso,0,sizeof(StrRetornoChaveAcesso));
			char StrRetornoSitCod[4]; memset(StrRetornoSitCod,0,sizeof(StrRetornoSitCod));

			iReturn = tEnvioUnitContingenciaOffline_NFCe_Daruma(StrRetornoCNPJ, StrRetornoSerie, StrRetornoNumNota, StrRetornoProtocolo,StrRetornoChaveAcesso,StrRetornoSitCod);
			printf("\nRetorno do metodo: %d\n", iReturn);
			printf("CNPJ: %s \n", StrRetornoCNPJ);
			printf("Numero de Serie: %s \n", StrRetornoSerie);
			printf("Numero da Nota: %s \n", StrRetornoNumNota);
			printf("Protocolo de Autorizacao: %s \n", StrRetornoProtocolo);
			printf("Chave de Acesso: %s \n", StrRetornoChaveAcesso);
			printf("Situacao: %s \n", StrRetornoSitCod);
		}; break;
        #pragma endregion

		#pragma region 61 tEnvioUnitContingenciaCancOffline_NFCe_Daruma
		case 61: 
		{	
			char StrRetornoCNPJ[15]; memset(StrRetornoCNPJ,0,sizeof(StrRetornoCNPJ));
			char StrRetornoSerie[4]; memset(StrRetornoSerie,0,sizeof(StrRetornoSerie));
			char StrRetornoNumNota[10]; memset(StrRetornoNumNota,0,sizeof(StrRetornoNumNota));
			char StrRetornoProtocolo[41]; memset(StrRetornoProtocolo,0,sizeof(StrRetornoProtocolo));
			char StrRetornoChaveAcesso[45]; memset(StrRetornoChaveAcesso,0,sizeof(StrRetornoChaveAcesso));
			char StrRetornoSitCod[4]; memset(StrRetornoSitCod,0,sizeof(StrRetornoSitCod));

			iReturn = tEnvioUnitContingenciaCancOffline_NFCe_Daruma(StrRetornoCNPJ, StrRetornoSerie, StrRetornoNumNota, StrRetornoProtocolo,StrRetornoChaveAcesso,StrRetornoSitCod);
			printf("\nRetorno do metodo: %d\n", iReturn);
			printf("CNPJ: %s \n", StrRetornoCNPJ);
			printf("Numero de Serie: %s \n", StrRetornoSerie);
			printf("Numero da Nota: %s \n", StrRetornoNumNota);
			printf("Protocolo de Autorizacao: %s \n", StrRetornoProtocolo);
			printf("Chave de Acesso: %s \n", StrRetornoChaveAcesso);
			printf("Situacao: %s \n", StrRetornoSitCod);
		}; break;
        #pragma endregion

		#pragma region 62 rUltimaCtg_NFCe_Daruma
		case 62: 
		{
			char StrRetornoUltimaCtg[1024*100]; memset(StrRetornoUltimaCtg,0,sizeof(StrRetornoUltimaCtg));
			char StrRetornoTipoCtg[5]; memset(StrRetornoTipoCtg,0,sizeof(StrRetornoTipoCtg));

			iReturn = rUltimaCtg_NFCe_Daruma(StrRetornoUltimaCtg, StrRetornoTipoCtg);
			printf("\nRetorno do metodo: %d\n", iReturn);
			printf("Ultima Ctg: %s \n", StrRetornoUltimaCtg);
			printf("Tipo da Contigencia: %s \n", StrRetornoTipoCtg);

		}; break;
        #pragma endregion

		#pragma region 63 tEnvioUnitCtg_NFCe_Daruma
		case 63: 
		{
			char StrRetornoCNPJ[15]; memset(StrRetornoCNPJ,0,sizeof(StrRetornoCNPJ));
			char StrRetornoSerie[4]; memset(StrRetornoSerie,0,sizeof(StrRetornoSerie));
			char StrRetornoNumNota[10]; memset(StrRetornoNumNota,0,sizeof(StrRetornoNumNota));
			char StrRetornoProtocolo[41]; memset(StrRetornoProtocolo,0,sizeof(StrRetornoProtocolo));
			char StrRetornoChaveAcesso[45]; memset(StrRetornoChaveAcesso,0,sizeof(StrRetornoChaveAcesso));
			char StrRetornoSitCod[4]; memset(StrRetornoSitCod,0,sizeof(StrRetornoSitCod));

			printf("Buffer da Ultima Contigencia: ");
			ler(aux1);
			iReturn = tEnvioUnitCtg_NFCe_Daruma(aux1, StrRetornoCNPJ,StrRetornoSerie,StrRetornoNumNota,StrRetornoProtocolo,StrRetornoChaveAcesso,StrRetornoSitCod);

			printf("\nRetorno do metodo: %d\n", iReturn);
			printf("CNPJ do Emitente: %s \n", StrRetornoCNPJ);
			printf("Serie: %s \n", StrRetornoSerie);
			printf("Numero da Nota: %s \n", StrRetornoNumNota);
			printf("Protocolo de Autorizacao: %s \n", StrRetornoProtocolo);
			printf("Chave de Acesso: %s \n", StrRetornoChaveAcesso);
			printf("Sit. Codgio: %s \n", StrRetornoSitCod);

		}; break;
        #pragma endregion

		#pragma region 64 tTransacaoAdministrativaTEF_NFCe_Daruma
		case 64: 
		{
			printf("Doc. Fiscal: ");
			ler(aux1);
			printf("Tipo Identificacao Cliente: ");
			ler(aux2);
			printf("Identificacao Cliente: ");
			ler(aux3);
			printf("Informacao Adicional: ");
			ler(aux4);
			printf("Taxa de Servico: ");
			ler(aux5);
			printf("Tipo Cartao: ");
			ler(aux6);
			printf("Uso Futuro: ");
			ler(aux7);

			iReturn = tTransacaoAdministrativaTEF_NFCe_Daruma(aux1, aux2,aux3,aux4,aux5,aux6,aux7);
			printf("\nRetorno do metodo: %d\n", iReturn);

		}; break;
        #pragma endregion

		#pragma region 65 tTransacaoCancelamentoTEF_NFCe_Daruma
		case 65: 
		{
			printf("Doc. Fiscal: ");
			ler(aux1);
			printf("Valor Total: ");
			ler(aux2);
			printf("Tipo Identificacao Cliente: ");
			ler(aux3);
			printf("Identificacao Cliente: ");
			ler(aux4);
			printf("NSU: ");
			ler(aux5);
			printf("Rede Adquirente: ");
			ler(aux6);
			printf("Data do Comprovante: ");
			ler(aux7);
			printf("Hora do Comprovante: ");
			ler(aux8);
			printf("Informacao Adicional: ");
			ler(aux9);
			printf("Taxa de Servico: ");
			ler(aux10);
			printf("Tipo Cartao: ");
			ler(aux11);
			printf("Uso Futuro: ");
			ler(aux12);

			iReturn = tTransacaoCancelamentoTEF_NFCe_Daruma(aux1, aux2,aux3,aux4,aux5,aux6,aux7,aux8,aux9,aux10,aux11,aux12);
			printf("\nRetorno do metodo: %d\n", iReturn);

		}; break;
        #pragma endregion

		#pragma region 66 tEnviar_NFe_Daruma
		case 66: 
		{	
			printf("Caminho do XML de envio: ");
			ler(aux1);
			printf("Caminho do XML de parametros: ");
			ler(aux2);
			printf("Quantidade de documentos que serao enviados: ");
			ler(aux3);
			int iaux3 = atoi(aux3);
			printf("Tipo de retorno(1 = variavel / 2 = arquivo): ");
			ler(aux4);
			int iaux4 = atoi(aux4);

			iReturn = tEnviar_NFe_Daruma(aux1, aux2, iaux3, iaux4,aux5);
			printf("\nRetorno do metodo: %d\n", iReturn);
			printf("\nRetorno: %s \n", aux5);
		}; break;
        #pragma endregion

		default: printf("Opcao invalida\n");
				printf("-------------------------------------------------------------------------------\n");
				printf("=======================< Aguardando Proximo Comando >==========================\n\n");
		}

		extendedReturns(iReturn);
		system("pause");
	}

	free(option);
	free(aux1);
	free(aux2);
	free(aux3);
	free(aux4);
	free(aux5);
	free(aux6);
	free(aux7);
	free(aux8);
	free(aux9);
	free(aux10);
	free(aux11);
	free(aux12);
	free(aux13);
	free(aux14);
}
void RetornoStatus()
{
	int i;

	char* option = (char*) malloc(sizeof(char*) * 200);
	char* aux1 = (char*) malloc(sizeof(char*) * 200);
	char* aux2 = (char*) malloc(sizeof(char*) * 200);
	char* aux3 = (char*) malloc(sizeof(char*) * 200);
	char* aux4 = (char*) malloc(sizeof(char*) * 200);
	char* aux5 = (char*) malloc(sizeof(char*) * 200);
	char* aux6 = (char*) malloc(sizeof(char*) * 200);
	char* aux7 = (char*) malloc(sizeof(char*) * 200);
	char* aux8 = (char*) malloc(sizeof(char*) * 200);
	char* aux9 = (char*) malloc(sizeof(char*) * 200);
	
	static char* functions[] = 
	{
	    #pragma region FUNCTIONS LIST NFCe
		"rLeituraX_NFCe_Daruma",						//1
		"rRecuperarXML_NFCe_Daruma",					//2
		"rRetornarInformacao_NFCe_Daruma",				//3
		"rRetornarInformacaoArq_NFCe_Daruma",			//4
		"rURLQrcode_NFCe_Daruma",						//5
		"rAvisoErro_NFCe_Daruma",						//6
		"rInfoEstendida_NFCe_Daruma",					//7
		"rStatusImpressora_NFCe_Daruma",				//8
		"rValidadeCertificado_NFCe_Daruma",				//9
		"rCFVerificarStatus_NFCe_Daruma",				//10
        #pragma endregion
	};

	for( ; ; ) 
	{
        Urmet();
		memset(aux1,0,sizeof(aux1));
		memset(aux2,0,sizeof(aux2));
		memset(aux3,0,sizeof(aux3));
		memset(aux4,0,sizeof(aux4));
		memset(aux5,0,sizeof(aux5));
		memset(aux6,0,sizeof(aux6));
		memset(aux7,0,sizeof(aux7));
		memset(aux8,0,sizeof(aux8));
		memset(aux9,0,sizeof(aux9));

		printf("\nMenu Principal -> Configuracao NFCe\n\n");

		for(i = 0; i < sizeof(functions) / sizeof(char*); i++) {
			printf("    [%s%d] - %s\n", i < 9 ? "0" : "", (i + 1), functions[i]);
		}

		printf("\n--------------------------------------------------------------------------");	
		printf("\nOBS: 0 para SAIR\n");
		printf("Escolha uma opcao para continuar: \n\n");	
		ler(option);

		if(!strcmp("0", option)) 
			break;

		switch(atoi(option)) 
		{
			#pragma region 1 rLeituraX_NFCe_Daruma
			case 1:{
				char StrRetorno[1024*100]; memset(StrRetorno,0,sizeof(StrRetorno));
				printf("Data: ");
				ler(aux1);
				printf("Serie: ");
				ler(aux2);
				printf("Tipo de Retorno (0- Impresso/1- Salva PDF/2- Salva XMl/ 3- Retorna Variavel: ");
				ler(aux3);
									
				if(strcmp(aux3,"3")==0){
					iReturn = rLeituraX_NFCe_Daruma(aux1,aux2,aux3,StrRetorno);
					printf("Retorno do metodo: %d\n", iReturn);
					printf("Retorno da Variavel: %s \n", StrRetorno);
				}
				else{
					iReturn = rLeituraX_NFCe_Daruma(aux1,aux2,aux3,StrRetorno);
					printf("Retorno do metodo: %d\n", iReturn);
				}
			};break;
			#pragma endregion

			#pragma region 2 rRecuperarXML_NFCe_Daruma
			case 2:{
				printf("Data Inicial: ");
				ler(aux1);
				printf("Data Final: ");
				ler(aux2);
				printf("Codigo de Status da Nota: ");
				ler(aux3);
				printf("Diretorio do XML: ");
				ler(aux4);

				iReturn = rRecuperarXML_NFCe_Daruma(aux1, aux2, aux3, aux4);
				printf("Retorno: %d\n",iReturn);
			}; break;
			#pragma endregion

			#pragma region 3 rRetornarInformacao_NFCe_Daruma
			case 3:{
				char StrRetorno[1024*100]; memset(StrRetorno,0,sizeof(StrRetorno));
				printf("Tipo Intervalo: ");
				ler(aux1);
				printf("Inicio: ");
				ler(aux2);
				printf("Fim: ");
				ler(aux3);
				printf("Serie: ");
				ler(aux4);
				printf("Chave de Acesso: ");
				ler(aux5);
				printf("Indice: ");
				ler(aux6);

				iReturn = rRetornarInformacao_NFCe_Daruma(aux1, aux2, aux3, aux4,aux5,aux6,StrRetorno);
				printf("Retorno do metodo: %d\n", iReturn);
				printf("Retorno da Variavel: %s \n", StrRetorno);
			}; break;
			#pragma endregion

			#pragma region 4 rRetornarInformacaoArq_NFCe_Daruma
			case 4:{
				printf("Tipo Intervalo: ");
				ler(aux1);
				printf("Inicio: ");
				ler(aux2);
				printf("Fim: ");
				ler(aux3);
				printf("Serie: ");
				ler(aux4);
				printf("Chave de Acesso: ");
				ler(aux5);
				printf("Indice: ");
				ler(aux6);
				printf("Diretorio e Nome do arquivo de retorno: ");
				ler(aux7);

				iReturn = rRetornarInformacaoArq_NFCe_Daruma(aux1, aux2, aux3, aux4,aux5,aux6,aux7);
				printf("Retorno do metodo: %d\n", iReturn);

			}; break;
			#pragma endregion

			#pragma region 5 rURLQrcode_NFCe_Daruma
			case 5:{
				iReturn = rURLQrcode_NFCe_Daruma(aux1);
				printf("URLQrcode_NFCe_Daruma: %s",  aux1);
			}; break;
			#pragma endregion

			#pragma region 6 rAvisoErro_NFCe_Daruma
			case 6:{
				iReturn = rAvisoErro_NFCe_Daruma(aux1, aux2);
				printf("Retorno: %d\n",iReturn);
				printf("Codigo erro: %s", aux1);
				printf("|Mensagem do erro: %s", aux2);
			}; break;
			#pragma endregion

			#pragma region 7 rInfoEstendida_NFCe_Daruma
			case 7:{
				printf("Indice: ");
				ler(aux1);
				iReturn = rInfoEstendida_NFCe_Daruma(aux1, aux2);
				printf("Retorno: %d\nInformacao retornada: %s\n",iReturn, aux2);
			}; break;
			#pragma endregion

			#pragma region 8 rStatusImpressora_NFCe_Daruma
			case 8:{
				iReturn = rStatusImpressora_NFCe_Daruma();
				printf("rStatusImpressora_NFCe_Daruma: %d\n",iReturn);
			}; break;
			#pragma endregion
			
			#pragma region 9 rValidadeCertificado_NFCe_Daruma
			case 9:{
				char StrRetorno[9]; memset(StrRetorno,0,sizeof(StrRetorno));
				char StrRetorno2[5]; memset(StrRetorno2,0,sizeof(StrRetorno2));

				iReturn = rValidadeCertificado_NFCe_Daruma(StrRetorno,StrRetorno2);
				
				printf("\nRetorno do metodo: %d\n", iReturn);
				printf("Data de Vencimento: %s \n", StrRetorno);
				printf("Dias Restantes: %s \n", StrRetorno2);
			}; break;
			#pragma endregion

			#pragma region 10 rCFVerificarStatus_NFCe_Daruma
			case 10:{
				iReturn = rCFVerificarStatus_NFCe_Daruma();
				printf("rCFVerificarStatus_NFCe_Daruma: %d\n",iReturn);
			}; break;
            #pragma endregion
            
			default: printf("Opcao invalida\n");
				printf("-------------------------------------------------------------------------------\n");
				printf("=======================< Aguardando Proximo Comando >==========================\n\n");
		}

		extendedReturns(iReturn);
		system("pause");
	}
	free(option);
	free(aux1);
	free(aux2);
	free(aux3);
	free(aux4);
	free(aux5);
	free(aux6);
	free(aux7);
	free(aux8);
	free(aux9);
}
void Test() 
{
	int i;
	int x;
	int cupom;
	int item;
	char* option = (char*) malloc(sizeof(char*) * 200);
	char* aux1 = (char*) malloc(sizeof(char*) * 200);
	char* aux2 = (char*) malloc(sizeof(char*) * 200);
	char* aux3 = (char*) malloc(sizeof(char*) * 200);
	char* aux4 = (char*) malloc(sizeof(char*) * 200);
	char codAvErro [5];
	char mensagem [40000]; 
	
	static char* functions[] = 
	{
	    #pragma region FUNCTIONS LIST NFCe
		"Testar Impressora",					//1
		"Testar Servidor",						//2
		"Teste de Venda Bufferizada",			//3
		"Teste de Venda Bufferizada com TEF",	//4
        #pragma endregion
	};

	for( ; ; ) 
	{
        Urmet();
		printf("\nMenu Principal -> Configuracao NFCe\n\n");

		memset(aux1,0,sizeof(aux1));
		memset(aux2,0,sizeof(aux2));
		memset(aux3,0,sizeof(aux3));
		memset(aux4,0,sizeof(aux4));
		memset(codAvErro,0,sizeof(codAvErro));
		memset(mensagem,0,sizeof(mensagem));

		for(i = 0; i < sizeof(functions) / sizeof(char*); i++) {
			printf("    [%s%d] - %s\n", i < 9 ? "0" : "", (i + 1), functions[i]);
		}

		printf("\n--------------------------------------------------------------------------");	
		printf("\nOBS: 0 para SAIR\n");
		printf("Escolha uma opcao para continuar: \n\n");	
		ler(option);

		if(!strcmp("0", option)) 
			break;

		if(atoi(option)>2)
		{
			printf("\n\nVERIFICANDO SE EXISTE VENDA ABERTA....\n");
			iReturn = rCFVerificarStatus_NFCe_Daruma();
			if ((iReturn>0) && (iReturn<5))
			{
				printf("*****EXISTE NF ABERTA, CHAMANDO CANCELAMENTO*****");
				iReturn = tCFCancelar_NFCe_Daruma((char*)"",(char*)"",(char*)"",(char*)"",(char*)"");
				printf("\nRetorno tCFCancelar_NFCe: %d\n", iReturn);
				printf("***********************************************\n");
			}
		}

		switch(atoi(option)) 
		{
		    #pragma region 1 Testar Impressora
			case 1: 
			{
				#pragma region Text
				char szTest[2000]; _memset(szTest);
				strcat(szTest,"<bmp></bmp>Daruma Developers<l>");
				strcat(szTest,"CNPJ-00.000.000/0000-00   I.E-000000000000<l>");
				strcat(szTest,"Av. Shishima, Urbanova, So Jos dos Campos-SP<l>");
				strcat(szTest,"------------------------------------------------<l>");
				strcat(szTest,"        DANFE NFC-e - Documento Auxiliar<l>");
				strcat(szTest,"                DOCUMENTO DE TESTE<l>");
				strcat(szTest,"<b>No permite aproveitamento de crdito de ICMS</b><l>");
				strcat(szTest,"------------------------------------------------<l>");
				strcat(szTest,"<c>Item  Cod.   Descricao         Qtde Un   VlrUnit   VlrTot</c><l>");
				strcat(szTest,"------------------------------------------------<l>");
				strcat(szTest,"<c>001 123456789098765432  C           53.56 C X 5.25 281.19</c><l>");
				strcat(szTest,"<c>002 123456  Chinelo de dedo de teste para a impresso da DANFE da NFCe dsaldsajdsalkjdsalkadsljkadsjlksdakjlsdakljdasjkladsjkdalsdakj500</c><l>");
				strcat(szTest,"<c>500                  Kg     X 62.30              31150.00</c><l>");
				strcat(szTest,"------------------------------------------------<l>");
				strcat(szTest,"QTD. TOTAL DE ITENS                          002<l>");
				strcat(szTest,"VALOR TOTAL R$                           5143.56<l>");
				strcat(szTest,"<l>");
				strcat(szTest,"FORMA DE PAGAMENTO                    Valor Pago<l>");
				strcat(szTest,"Cheque                                     35.75<l>");
				strcat(szTest,"------------------------------------------------<l>");
				strcat(szTest,"Informao dos Tributos Totais Incidentes(Lei Federal 12.741/2012) 1,00<l>");                          
				strcat(szTest,"------------------------------------------------<l>");
				strcat(szTest,"             AREA DE MENSAGEM FISCAL            <l>");
				strcat(szTest,"<c>Nmero:00000089 Srie:0 Emisso:00/00/2000 00:00:00 - Via<c><l>");
				strcat(szTest,"<c>                        consumidor</c><l>");
				strcat(szTest,"Consulte pela Chave de Acesso em: http://www.desenvolvedoresdaruma.com.br<l>");
				strcat(szTest,"                 CHAVE DE ACESSO                <l>");
				strcat(szTest,"<c>  0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000</c><l>");
				strcat(szTest,"------------------------------------------------<l>");
				strcat(szTest,"                   CONSUMIDOR                   <l>");
				strcat(szTest,"      CNPJ/CPF/ID Estrangeiro - 00000000000<l>");
				strcat(szTest,"------------------------------------------------<l>");
				strcat(szTest,"         Consulta via leitor de QR Code<l>");
				strcat(szTest,"<ce><qrcode>http://www.desenvolvedoresdaruma.com.br</qrcode></ce><l>");
				strcat(szTest,"<c> Protocolo de Autorizao: 99999999 00/00/0000 00:00:00</c><sl>4</sl><gui></gui>");
				#pragma endregion

				iReturn = iImprimirTexto_DUAL_DarumaFramework(szTest,strlen(szTest));
				printf("Retorno: %d\n", iReturn);
			}; break;
			#pragma endregion
            
            #pragma region  2 Testar Servidor
			case 2: 
			{
				iReturn = rStatusWS_NFCe_Daruma();
				printf("Retorno: %d\n",iReturn);

			}; break;
            #pragma endregion

			#pragma region  3 Teste de Venda Bufferizada
			case 3: 
			{
				printf ("Numero de cupons: ");
				ler (aux1);
				printf ("Numero de itens: ");
				ler (aux2);
				cupom = atoi(aux1);
				item = atoi(aux2);
				i=0;
				x=0;
				char desc[100]; memset(desc,0,sizeof(desc));
				for (i=0; i<cupom; i++)
				{
					printf("\nAguarde");
					iReturn = aCFAbrir_NFCe_Daruma((char*)"", (char*)"", (char*)"", (char*)"", (char*)"", (char*)"", (char*)"", (char*)"", (char*)"");
					printf("\nRetorno aCFAbrir: %d", iReturn);
					for (x=1; x<=item; x++){
						sprintf(desc,"Item teste %d",x);
						iReturn = aCFVenderCompleto_NFCe_Daruma((char*)"07,00",(char*) "20",(char*) "0,10", (char*)"D$", (char*)"0,00", (char*)"1234", (char*) "",(char*) "",(char*) "und", (char*)"Item 12345",(char*)"CEST=2005000;cEAN=7622300861872;cEANTrib=7622300861872;");
						printf("\naCFVender_NFCe item %d: %d", x, iReturn);
					}
					iReturn = aCFTotalizar_NFCe_Daruma((char*)"D$", (char*)"0,00");
					printf("\naCFTotalizar_NFCe: %d", iReturn);
					iReturn = aCFEfetuarPagamento_NFCe_Daruma((char*)"Dinheiro", (char*)"0,00");//para fazer pagamento do total
					printf("\naCFEfetuarPagamento_NFCe: %d", iReturn);
					iReturn = tCFEncerrar_NFCe_Daruma((char*)"");
					printf("\ntCFEncerrar_NFCe: %d", iReturn);
					memset(codAvErro,0,sizeof(codAvErro));
					memset(mensagem,0,sizeof(mensagem));
					rAvisoErro_NFCe_Daruma(codAvErro, mensagem);
					printf("\nCodigo erro: %s", codAvErro);
					printf(" |Mensagem do erro: %s", mensagem);
					printf("\nConcluiu venda....");
				}

			}; break;
            #pragma endregion

			#pragma region  4 Teste de Venda Bufferizada com TEF
			case 4: 
			{
				i=0;
				x=0;

				printf ("Numero de Itens: ");
				ler (aux1);
				printf ("Valor do Item: ");
				ler (aux2);
				printf ("Meio de Pagamento: ");
				ler (aux3);
				printf ("Valor do Pagamento: ");
				ler (aux4);
				item = atoi(aux1);
				
				char desc[100]; memset(desc,0,sizeof(desc));
				iReturn = regAlterarValor_Daruma("TEF\\TransacaoAutomatica", "1");
				printf("\nRetorno regAlterarValor_Daruma: %d", iReturn);

				iReturn = aCFAbrir_NFCe_Daruma((char*)"", (char*)"", (char*)"", (char*)"", (char*)"", (char*)"", (char*)"", (char*)"", (char*)"");
				printf("\nRetorno aCFAbrir: %d", iReturn);
				for (x=1; x<=item; x++){
					sprintf(desc,"Item teste %d",x);
					iReturn = aCFVenderCompleto_NFCe_Daruma((char*)"07,00",(char*) "1.00",aux2, (char*)"D$", (char*)"0,00", (char*)"1234", (char*) "",(char*) "",(char*) "und", (char*)"Item 12345",(char*)"CEST=2005000;cEAN=7622300861872;cEANTrib=7622300861872;");
					printf("\naCFVenderCompleto_NFCe_Daruma item %d: %d", x, iReturn);
				}
				iReturn = aCFTotalizar_NFCe_Daruma((char*)"D$", (char*)"0,00");
				printf("\naCFTotalizar_NFCe: %d", iReturn);
				iReturn = aCFEfetuarPagamento_NFCe_Daruma(aux3, aux4);
				printf("\naCFEfetuarPagamento_NFCe: %d", iReturn);
				iReturn = tCFEncerrar_NFCe_Daruma((char*)"Obrigado e volte sempre!");
				printf("\ntCFEncerrar_NFCe: %d", iReturn);
				memset(codAvErro,0,sizeof(codAvErro));
				memset(mensagem,0,sizeof(mensagem));
				rAvisoErro_NFCe_Daruma(codAvErro, mensagem);
				printf("\nCodigo erro: %s", codAvErro);
				printf(" |Mensagem do erro: %s", mensagem);
				printf("\nConcluiu venda....");

			}; break;
            #pragma endregion
            
			default: printf("Opcao invalida\n");
				printf("-------------------------------------------------------------------------------\n");
				printf("=======================< Aguardando Proximo Comando >==========================\n\n");
		}

		extendedReturns(iReturn);
		system("pause");
	}
	free(option);
	free(aux1);
	free(aux2);
	free(aux3);
	free(aux4);
}